

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 1
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
    variable allchans 0

    variable Rmsg ""
    variable Wmsg ""

    source [file join V1724 Registers.tcl]

    variable ModuleName v1724
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1



     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

#    register access procedures

   proc ReadRegister {RegName} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable Rmsg

       set r $ModuleName#$ModuleIndex
       set z [catch {::namespace inscope ::urn:VMEAccessServer ReadRegister $r.$RegName} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
       } else {
           InsertLog "ReadRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc 0
       }
       return $rc
   }

   proc WriteRegister {RegName RegData} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable allmodules
       variable Wmsg

       if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegisters $r.$RegName $RegData} Wmsg]

       if {$z == 0} {
#           InsertLog "WriteRegister $r.$RegName returned: [lindex $Wmsg 5]"
       } else {
           InsertLog "WriteRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc show_variables {} {
        variable allchans
        variable allmodules
        variable LogFlag
        variable ShowLogFlag
        variable Register
        variable Rmsg
        variable Wmsg

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag "
             InsertLog "allchans=$allchans; allmodules=$allmodules"
             InsertLog "Register=$Register"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
   }

   proc do_RegisterHelp {} {
       variable RegisterHelp
       variable Register

       Alert "$RegisterHelp($Register)"

  }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

    proc UpdateModule {} {
        variable online
        variable overflow
        variable zero
        variable stopstart
        variable fastclear
        variable fullscale

        variable OperationMode
        for {set i 0} {$i < 32} {incr i} {variable Enable$i}
        for {set i 0} {$i < 32} {incr i} {variable Threshold$i}

 
        set fastclear [ReadRegister Fast_Clear_Window]
        set fullscale [ReadRegister FullScaleRange]

            set vl [ReadRegister Bit_Set_2]
            set OperationMode $vl
            set online [expr $vl >> 1 & 1]
            set overflow [expr $vl >> 3 & 1]
            set zero [expr $vl >> 4 & 1]
            set stopstart [expr $vl >> 10 & 1]

        for {set i 0} {$i < 32} {incr i} {
            set Threshold$i [ReadRegister Threshold$i]
            set Enable$i [ReadRegister Disable$i]
        }
   }

    proc do_SetOperationMode {w v} {

       switch $w {
           ONLINE    {set data 0x02}
           OVERFLOW  {set data 0x08}
           THRESHOLD {set data 0x10}
           VALC      {set data 0x20}
           SSE       {set data 0x80}
           SSSE      {set data 0x2000}
           STOPSTART {set data 0x400}
           EVMODE    {set data 0x1000}
           EVCMODE   {set data 0x4000}
           BIT15     {set data 0x8000}
       }

       switch $v {
          0   {WriteRegister Bit_Set_2 $data}
          1   {WriteRegister Bit_Clear_2 $data}
       }
    }

    proc do_OperationMode {v} {
       WriteRegister Bit_Clear_2 0xffff
       WriteRegister Bit_Set_2 $v
    }

     proc do_SetThreshold {j vl} {
        variable alltdcs

           for {set i 0} {$i < 32} {incr i 1} {
              if {$alltdcs == 0 && $j != $i} {continue}

              do_Threshold $i $vl
           }
     }

     proc do_Threshold {i vl} {WriteRegister Threshold$i $vl}

     proc do_FastClear {vl} {WriteRegister Fast_Clear_Window $vl}

     proc do_FullScale {vl} {WriteRegister FullScaleRange $vl}
 
     proc do_SetEnable {j vl} {
        variable alltdcs

        if {$vl == "true"} {set Vl 0} else {set Vl 1}

          for {set i 0} {$i < 32} {incr i 1} {
            if {$alltdcs == 0 && $j != $i} {continue}

            do_Enable $i $Vl
          }
     }

     proc do_Enable {i vl} {WriteRegister Disable$i $vl}

    proc do_Save {} {
        variable ::VMEConfig::ConfigBase
        variable ModuleIndex
        variable ModuleMenu

        variable OperationMode
        variable fastclear
        variable fullscale
        for {set i 0} {$i < 32} {incr i} {variable Enable$i}
        for {set i 0} {$i < 32} {incr i} {variable Threshold$i}

        set SaveFile [file join $ConfigBase V775.dat]

        set z [catch {open $SaveFile w} file]
        if {$z != 0} {
            Alert "Unable to access $SaveFile"
            InsertLog "[set file]"
            return
        }

        set SAV $ModuleIndex
        foreach module $ModuleMenu {
           do_Select $module
           InsertLog "Saving Settings for CAEN V775 modules"

           puts $file "$module OperationMode $OperationMode"
           puts $file "$module FastClear $fastclear"
           puts $file "$module FullScaleRange $fullscale"

           for {set i 0} {$i < 32} {incr i} {
               puts $file "$module Threshold$i [set Threshold$i]"
               puts $file "$module Enable$i [set Enable$i]"
           }
        }
        do_Select $SAV

        close $file

        InsertLog "Done"

        Elog INFORMATION "Settings for CAEN V775 modules updated in $SaveFile"
    }

    proc do_Restore {} {
        variable ::VMEConfig::ConfigBase
        variable ModuleIndex
        variable allmodules

        InsertLog "Restoring Settings for CAEN V775 modules"

        set SaveFile [file join $ConfigBase V775.dat]

        set z [catch {open $SaveFile r} file]
        if {$z != 0} {
            Alert "Unable to access $SaveFile"
            InsertLog "[set file]"
            return
        }

        set allmodules 0

        set SAV $ModuleIndex
        foreach item [split [read $file] \n] {
            if {[string length $item] == 0} {continue}
            set m [first $item]
            if {$m != $ModuleIndex} {do_Select $m}
            set p [second $item]
            set vl [third $item]
            switch -glob $p {
                OperationMode   {do_OperationMode $vl}
                FastClear       {do_FastClear $vl}
                FullScaleRange  {do_FullScale $vl}
                Threshold*      {do_Threshold [string range $p 9 end] $vl}
                Enable*         {do_Enable [string range $p 6 end] $vl}
            }
        }
        do_Select $SAV

        close $file

        InsertLog "Done"

        Elog INFORMATION "Settings for CAEN V775 modules restored from $SaveFile"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLCHANS   {variable allchans; set allchans [expr ($allchans + 1) & 1]}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}
  
                   REGISTER {variable Register; set Register [lindex $w 1]}
                   HELP     {do_RegisterHelp}

                   OFFSET  {
                       set i [lindex $w 1]
                       if {$i < 32} {UpdateModule; do_SetThreshold $i [lindex $w 2]}
                       if {$i == 32} {do_FastClear [lindex $w 2]}
                       if {$i == 33} {do_FullScale [lindex $w 2]}
                   }

                   ENABLE  {UpdateModule; do_SetEnable [lindex $w 1] [lindex $w 2]}

                   ONLINE    {do_SetOperationMode ONLINE [lindex $w 1]}
                   OVERFLOW  {do_SetOperationMode OVERFLOW [lindex $w 1]}
                   STOPSTART {do_SetOperationMode STOPSTART [lindex $w 1]}
                   ZERO      {do_SetOperationMode THRESHOLD [lindex $w 1]}

                   SAVE      {UpdateModule; do_Save}
                   RESTORE   {do_Restore}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
#       UpdateModule
    }

}   ;# end of if {$started == 0}

